#define Uses_MsgBox
#define Uses_TEvent

#include <tv.h>

#include "diskedit.h"
#include "ldrdlg.h"

TLdrBootDialog::TLdrBootDialog(const char *ldrname, int raw) :
       TDialog(TRect(16, 7, 63, 16), "OS2LDR file launch"),
       TWindowInit(TLdrBootDialog::initFrame)
{
   TView *control;
   options |= ofCenterX | ofCenterY;
   helpCtx  = hcLdrName;

   bf_name  = new TInputLine(TRect(13, 2, 42, 3), 29);
   bf_name->helpCtx = hcLdrName;
   insert(bf_name);
   insert(new THistory(TRect(42, 2, 45, 3), (TInputLine*)bf_name, 2));
   if (ldrname) setstrn(bf_name, ldrname, 64);

   insert(new TLabel(TRect(2, 2, 12, 3), "~F~ile name", bf_name));

   bf_opts = new TCheckBoxes(TRect(3, 5, 27, 7), new TSItem("~r~aw mode",
                             new TSItem("~n~o data sending", 0)));
   bf_opts->helpCtx = hcLdrOpts;
   insert(bf_opts);
   insert(new TLabel(TRect(2, 4, 10, 5), "~O~ptions", bf_opts));

   control = new TButton(TRect(33, 4, 43, 6), "~B~rowse", cmLdrBrowse, bfNormal);
   control->helpCtx = hcLdrBrowse;
   insert(control);
   control = new TButton(TRect(33, 6, 43, 8), "~G~o", cmLdrLaunch, bfDefault);
   control->helpCtx = hcLdrLoad;
   insert(control);

   selectNext(False);
}

void TLdrBootDialog::handleEvent( TEvent& event) {
   TDialog::handleEvent(event);
   if (event.what==evCommand) {
      switch (event.message.command)  {
         case cmLdrBrowse: {
            char *bn = getfname(1, "Select loader file", "A:\\*");
            if (bn) bf_name->setData(bn);
            clearEvent(event);
            // move focus to "Go"
            selectNext(False);
            break;
         }
         case cmLdrLaunch: {
            char *ldr = getstr(bf_name);
            if (ldr && *ldr) {
#ifdef __QSINIT__
               TProgram::application->suspend();
               u32t rc = bf_opts->mark(0) ? exit_rawcode(ldr, 0) :
                   exit_restart(ldr, 0, 0, bf_opts->mark(1)?QRST_NOHIST|QRST_NOCP:0);
               TProgram::application->resume();
               TProgram::application->redraw();
#else
               u32t rc = 14;
#endif
               SysApp.PrintPTErr(rc);
            }
            clearEvent(event);
            break;
         }
      }
   }
}

Boolean TLdrBootDialog::valid(ushort command) {
   Boolean rslt = TDialog::valid(command);
   if (rslt && (command == cmOK)) { }
   return rslt;
}
