#
# Include sdk.env environment
#

!include $(SDK_INSTALL_DIR)\build\$(SDK_BUILD_ENV)\sdk.env
!include qsinit.env

#
# Set the base output name and entry point
#

BASE_NAME         = qsinit
IMAGE_ENTRY_POINT = QSLoader

#
# Globals needed by master.mak
#

TARGET_APP = $(BASE_NAME)
SOURCE_DIR = $(SDK_INSTALL_DIR)\apps\$(BASE_NAME)
BUILD_DIR  = $(SDK_BUILD_DIR)\apps\$(BASE_NAME)
MODULE_LFLAGS = /MAP:$(BASE_NAME).map
MODULE_AFLAGS = /I$(QSINIT_DIR)\system\src\hc /I$(QSINIT_DIR)\system\src\ldrefi

#
# Include paths
#

!include $(SDK_INSTALL_DIR)\include\$(EFI_INC_DIR)\makefile.hdr
INC = -I $(SDK_INSTALL_DIR)\include\$(EFI_INC_DIR) \
      -I $(SDK_INSTALL_DIR)\include\$(EFI_INC_DIR)\$(PROCESSOR) $(INC)

# get qsefi32.h
INC = -I $(QSINIT_DIR)\system\src\ldrefi $(INC)

#!include makefile.hdr
INC = -I $(PROCESSOR) $(INC) -I hc -I $(BUILD_DIR)

#
# Libraries
#

LIBS = $(LIBS) $(SDK_BUILD_DIR)\lib\libefi\libefi.lib

INC_CVTS = $(BUILD_DIR)\qsbinfmt.h \
           $(BUILD_DIR)\qsinit.h \
           $(BUILD_DIR)\dskinfo.h \
           $(BUILD_DIR)\seldesc.h \
           $(BUILD_DIR)\cpudef.h \
           $(BUILD_DIR)\efnlist.h

#
# Default target
#

all : dirs $(BUILD_DIR)\$(PROCESSOR) $(LIBS) $(INC_CVTS) $(OBJECTS)

#
# Program object files
#

OBJECTS = $(OBJECTS) \
    $(BUILD_DIR)\qsloader.obj \
    $(BUILD_DIR)\expfuncs.obj \
    $(BUILD_DIR)\keyboard.obj \
    $(BUILD_DIR)\config.obj \
    $(BUILD_DIR)\console.obj \
    $(BUILD_DIR)\diskio.obj \
    $(BUILD_DIR)\switch.obj \
    $(BUILD_DIR)\load32.obj \
    $(BUILD_DIR)\clock.obj \
    $(BUILD_DIR)\logprn.obj \
    $(BUILD_DIR)\rtcode.obj \
    $(BUILD_DIR)\xcpt.obj

#
# Source file dependencies
#

$(BUILD_DIR)\qsloader.obj  : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\expfuncs.obj  : $(*B).c   $(INC_DEPS) pack2.c
$(BUILD_DIR)\keyboard.obj  : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\console.obj   : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\config.obj    : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\load32.obj    : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\diskio.obj    : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\clock.obj     : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\logprn.obj    : $(*B).c   $(INC_DEPS)
$(BUILD_DIR)\switch.obj    : $(*B).asm
$(BUILD_DIR)\rtcode.obj    : $(*B).asm
$(BUILD_DIR)\xcpt.obj      : $(*B).asm

#
# Handoff to master.mak
#

!include $(SDK_INSTALL_DIR)\build\master.mak

#
# this "Assembling..." message annoying me very much ;), so hide it and display
# error text only on actual error 
#
{$(SOURCE_DIR)}.asm{$(BUILD_DIR)}.obj:
    @echo $(*B).asm
    $(ASM) $(AFLAGS) $(MODULE_AFLAGS) /Fo$@ $< >$*.err & if errorlevel 1 type $*.err

$(BUILD_DIR)\qsbinfmt.h : $(QSINIT_DIR)\system\src\init\inc\qsbinfmt.inc
    @echo $(*B).inc
    $(INC2H) $** $@ /tq /p1

$(BUILD_DIR)\qsinit.h : $(QSINIT_DIR)\system\src\init\inc\qsinit.inc
    @echo $(*B).inc
    $(INC2H) $** $@ /tq /p1

$(BUILD_DIR)\dskinfo.h : $(QSINIT_DIR)\system\src\init\inc\dskinfo.inc
    @echo $(*B).inc
    $(INC2H) $** $@ /tq /p1

$(BUILD_DIR)\seldesc.h : $(QSINIT_DIR)\system\src\hc\inc\seldesc.inc
    @echo $(*B).inc
    $(INC2H) $** $@ /tq /p1

$(BUILD_DIR)\cpudef.h : $(QSINIT_DIR)\system\src\hc\inc\cpudef.inc
    @echo $(*B).inc
    $(INC2H) $** $@ /tq /p1

$(BUILD_DIR)\efnlist.h : $(QSINIT_DIR)\system\src\ldrefi\inc\efnlist.inc
    @echo $(*B).inc
    $(INC2H) $** $@ /tq /p1
