;
; QSINIT EFI loader
; 64-bit runtime functions
;
                .code


;----------------------------------------------------------------
;s32t  bsf64(u64t value);
bsf64           proc    public
                bsf     rax,rcx                                 ;
                jnz     @@bsfq_done                             ;
                or      eax,-1                                  ;
@@bsfq_done:
                ret                                             ;
bsf64           endp                                            ;

;----------------------------------------------------------------
;s32t  bsr64(u64t value);
bsr64           proc    public
                bsr     rax,rcx                                 ;
                jnz     @@bsrq_done                             ;
                or      eax,-1                                  ;
@@bsrq_done:
                ret                                             ;
bsr64           endp                                            ;

;----------------------------------------------------------------
;char* strcpy(char *dst, const char *src);
strcpy          proc    public
@@str1          =  4                                            ;
@@str2          =  8                                            ;
                push    rsi                                     ;
                push    rdi                                     ;
                mov     rsi,rdx                                 ;
                mov     rdi,rcx                                 ;
                cld                                             ;
@@scpy_cpy:
                lodsb                                           ;
                stosb                                           ;
                test    al,al                                   ;
                jnz     @@scpy_cpy                              ;
                pop     rdi                                     ;
                mov     rax,rcx                                 ;
                pop     rsi                                     ;
                ret                                             ;
strcpy          endp

;----------------------------------------------------------------
;wchar_t* wcscpy(wchar_t *dst, const wchar_t *src);
wcscpy          proc    public
@@str1          =  4                                            ;
@@str2          =  8                                            ;
                push    rsi                                     ;
                push    rdi                                     ;
                mov     rsi,rdx                                 ;
                mov     rdi,rcx                                 ;
                cld                                             ;
@@wscpy_cpy:
                lodsw                                           ;
                stosw                                           ;
                test    ax,ax                                   ;
                jnz     @@wscpy_cpy                             ;
                pop     rdi                                     ;
                mov     rax,rcx                                 ;
                pop     rsi                                     ;
                ret                                             ;
wcscpy          endp

;----------------------------------------------------------------
;u64t wcslen(const wchar_t *str);
wcslen          proc    public
                push    rdi                                     ;
                jrcxz   @@wcslen_null                           ;
                mov     rdi,rcx                                 ;
                cld                                             ;
                xor     rcx,rcx                                 ;
                dec     rcx                                     ;
                xor     ax,ax                                   ;
          repne scasw                                           ;
                not     rcx                                     ;
                dec     rcx                                     ;
@@wcslen_null:
                mov     rax,rcx                                 ;
                pop     rdi                                     ;
                ret                                             ;
wcslen          endp                                            ;

;----------------------------------------------------------------
;u64t strlen(const char *s);
strlen          proc    public
                push    rdi                                     ; avoid supplied
                jrcxz   @@strlen_null                           ; NULL (return 0)
                mov     rdi,rcx                                 ;
                cld                                             ;
                xor     rcx,rcx                                 ;
                dec     rcx                                     ;
                xor     al,al                                   ;
          repne scasb                                           ;
                not     rcx                                     ;
                dec     rcx                                     ;
@@strlen_null:
                mov     eax,ecx                                 ;
                pop     rdi                                     ;
                ret                                             ;
strlen          endp                                            ;


                end
